/* Tsinghuaeolus soccer client for Robocup2001
 *
 * Computer Science Department
 * State Key Lab of Intelligent Technology and Systems
 * Tsinghua University
 * 
 * Copyright (C) 2001 Tsinghuaeolus
 * Team Leader : Lishi
 * Team memebers : ChenJiang, YaoJinyi, CaiYunpeng
 *
 * We thank CMU for CMU98 was used for reference in our initial stage.
 *
 * You may copy and distribute this program freely as long as you retain this notice.
 * If you make any changes or have any comments we would appreciate a message to yjy01@mails.tsinghua.edu.cn.
 * For more information, please see http://www.lits.tsinghua.edu.cn/RoboCup
 */

#include "stdafx.h"

#include "netif.h"
#include "Global.h"
#include "Params.h"
#include "utils.h"
#include <stdlib.h>
#include <stdio.h>

/*  timer handle of information process and ai process */
HANDLE siginf = NULL, sigctrl = NULL;
CRITICAL_SECTION parse_update_mutex;
HANDLE newcycle_event =NULL, newsightinfo_event = NULL, newsenseinfo_event = NULL;
UINT WaitServerTimer = NULL;
DWORD  waittime = 20;
float  CP_UpdateAItime = 25.0f;
/* Interval = SP_simulator_step / Interrupts */
void InitializeObjs();

DWORD WINAPI InfProc(LPVOID lpParameter);
DWORD WINAPI CtrlProc(LPVOID lpParameter);
void CALLBACK CheckServer(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime);
int InitInstance()
{
/**********    open files     **********/
#ifdef _LOG
	//rec.AssociateFile(CP_logfile);
	rec.SetLabel(LOG_SYNC, "Sync");
	rec.SetLabel(LOG_NONE,"");
	rec.SetLabel(LOG_SENDACTION, "SendAction");
	rec.SetLabel(LOG_STOPWATCH,"StopWatch");
	rec.SetLabel(LOG_ACTION, "Action");
	rec.SetLabel(LOG_UPDATE, "Update");
	rec.SetLabel(LOG_MISS, "Miss");
	rec.SetLabel(LOG_COLLIDE, "Coll");
	rec.SetLabel(LOG_KICK, "Kick");
	rec.SetLabel(LOG_UNKPLAYER, "Unk P");
	rec.SetLabel(LOG_HEAR, "Hear");
	rec.SetLabel(LOG_IT, "Interception");
	rec.SetLabel(LOG_PASS,"Pass"); 
	rec.SetLabel(LOG_SEE,"See");
	rec.SetLabel(LOG_DEFENSE, "Defense");
	rec.SetLabel(LOG_MEDIATION, "Mediation");
	rec.SetLabel(LOG_BUG, "BUG");
	rec.SetLabel(LOG_SITUATION, "Situation");
	rec.SetLabel(LOG_GOALIE, "Goalie");
	rec.SetLabel(LOG_SETPLAY, "SetPlay");
	rec.SetLabel(LOG_POSITIONING, "Positioning");
	rec.SetLabel(LOG_DRIBBLE,"Dribble");
	rec.SetLabel(LOG_OAKICK, "Oa kick");
	rec.SetLabel(LOG_VISUAL, "Visual");
	rec.SetLabel(LOG_DEFEXTEND, "Def extend");
	rec.SetLabel(LOG_VISUALREQ,"VReq");
	rec.SetLabel(LOG_VDEC, "VDec");
	rec.SetLabel(LOG_SHOOT, "Shoot");
	rec.SetLabel(LOG_HANDLEBALL, "HB");
	rec.SetLabel(LOG_OFFSIDE, "Offside");

	//rec.SetLogOn(LOG_NONE);
	//rec.SetLogOn(LOG_SENDACTION);
	//rec.SetLogOn(LOG_ACTION);
	//rec.SetLogOn(LOG_IT);
	//rec.SetLogOn(LOG_DRIBBLE);
//	rec.SetLogOn(LOG_PASS);
	//rec.SetLogOn(LOG_HEAR);
//	rec.SetLogOn(LOG_HANDLEBALL);
	//rec.SetLogOn(LOG_DEFEXTEND); 
	//rec.SetLogOn(LOG_POSITIONING);
	//rec.SetLogOn(LOG_OFFSIDE);
	//rec.SetLogOn(LOG_UPDATE);
	//rec.SetLogOn(LOG_STOPWATCH);
	//rec.SetLogOn(LOG_UNKPLAYER);
	//rec.SetLogOn(LOG_VDEC); 
	//rec.SetLogOn(LOG_MEDIATION); 
	//rec.SetLogOn(LOG_DRIBBLE); 
	//rec.SetLogOn(LOG_OAKICK);
	rec.SetLogOn(LOG_MISS);
	rec.SetLogOn(LOG_SHOOT);

	//recmsg.AssociateFile(CP_recfile);
	recmsg.SetLabel(LOG_SYNC,"Sync");
	recmsg.SetLabel(LOG_STOPWATCH,"StopWatch");
	recmsg.SetLabel(LOG_HEAR, "Hear");
	recmsg.SetLabel(LOG_MISS, "Miss");

	recmsg.SetLogOn(LOG_NONE);
	//recmsg.SetLogOn(LOG_HEAR);
	//recmsg.SetLogOn(LOG_MISS);
	recmsg.SetLogOn(LOG_STOPWATCH); 
	//recmsg.SetLogOn(LOG_SYNC);
#endif

	enable_my_error = 0;
	sock = init_connection(SP_host, SP_port);

	action.send_init_message();//sent init message

	if (!wait_message(recvbuf,sock)){// wait for server's reply
		my_error("No response form server!");
		return false;
	}

	sensory.Parse_initialize_message(recvbuf);
	my_error("Connected!");


/**********   Initialize Objects ***************/
	InitializeObjs();

/* set the socket back to blocking		*/
	unsigned long arp = 0;
	ioctlsocket(sock->socketfd, FIONBIO, &arp);

	InitializeCriticalSection(&parse_update_mutex); //initialize mutex	

	newcycle_event = CreateEvent(NULL, TRUE, FALSE, NULL);
	newsightinfo_event = CreateEvent(NULL, TRUE, FALSE, NULL);
	newsenseinfo_event = CreateEvent(NULL, TRUE, FALSE, NULL);

	WaitServerTimer = SetTimer(hWND, 1, 2000, CheckServer);

	watch.Changeview();//
	if ((siginf = CreateThread(NULL, 0, InfProc, NULL, 0, NULL)) == NULL){
		my_error("creat thread error");
		return false;
	}
	
	SetThreadPriority(siginf,THREAD_PRIORITY_TIME_CRITICAL);//enhance the priority of the thread
	
/********************   start control process   ******************/
	if ((sigctrl = CreateThread(NULL, 0, CtrlProc, NULL, 0, NULL)) == NULL){
		my_error("creat thread error");
		return false;
	}
	
	SetThreadPriority(sigctrl,THREAD_PRIORITY_HIGHEST);

	return true;
}


/*	Information  process	*/
DWORD WINAPI InfProc(LPVOID lpParameter){
	if (!ServerAlive) return 0;
	while(receive_message(recvbuf,sock) == 1){
		if (!ServerAlive) return 0;
		watch.SetNewmsgTime();//when receive new msg
		NoResponseFromServer = 0; // There is response frome server

		EnterCriticalSection(&parse_update_mutex);
		sensory.Parse(recvbuf);
		DoRecord(recvbuf);
// Notify the CtrlProc about some events				

		if(sensory.LastMsgIsSight()){
			SetEvent(newsightinfo_event);			
			watch.SetSeeTime(sensory.LatestTime);
			DoRecord(LOG_STOPWATCH,"See Time %f sight gap %.2f(%d %d) chview gap %.2f",
				watch.GetSeeTime(sensory.LatestTime), watch.SightIntervalBetween(sensory.PrevSightTime, sensory.LastSightTime),
				sensory.PrevSightTime, sensory.LastSightTime, watch.Sincechangeview(sensory.LastSightTime));
		}

		if(sensory.LastMsgIsSense()){
			SetEvent(newsenseinfo_event);
		}

		if (sensory.LatestTime > sensory.PrevInterruptTime || 
			(situation.ClockStopped && sensory.LastMsgIsSense())){
			//It is a new Cycle
			watch.SetCycleStartTime(sensory.LatestTime);//when the cycle starts
			
			//if (!sensory.LastMsgIsSense())	ResetEvent(newsenseinfo_event);

			if (!sensory.LastMsgIsSight())
				ResetEvent(newsightinfo_event);

			watch.SetNotificationTime(sensory.LatestTime); // when notify the control process
			SetEvent(newcycle_event);
			DoRecord(LOG_STOPWATCH,"Last Cycle%f,New Cycle Notify%f",watch.LastCycleLength(sensory.LatestTime),watch.GetNotificationTime(sensory.LatestTime));
		}
		LeaveCriticalSection(&parse_update_mutex);
	}
	return 0;
}

/*	Control Process	*/
DWORD WINAPI CtrlProc(LPVOID plParameter){
	int behave();

	HANDLE Handles[2];
	Handles[0] = newsenseinfo_event;
	Handles[1] = newsightinfo_event;
	if (!ServerAlive) return 0;
	
	int logwaitcounts = 0;
	int logwaitfails = 0;
	bool logwait;
	float predictsightime;
	while(1){
		//WaitForSingleObject(newcycle_event, INFINITE);// wait for the new cycle
		WaitForSingleObject(newsenseinfo_event, INFINITE);// wait for the new cycle		
	
		if (!situation.ClockStopped && sensory.LatestTime - 1 > situation.LastInterruptTime){
			my_error("Miss %d cycles?", sensory.LatestTime - 1 - situation.LastInterruptTime);
			DoLog(LOG_MISS, "%d cycles", sensory.LatestTime - 1 - situation.LastInterruptTime);
		}
		situation.LastInterruptTime = sensory.LatestTime;
		watch.SetCurrentCycle(sensory.LatestTime);
		watch.RecvNotification();
		
		logwait = false;
		if(sensory.LastSightTime < sensory.LatestTime){
			predictsightime = watch.PredictNextSight();
			if(predictsightime < (float)SP_simulator_step - CP_UpdateAItime){
				logwaitcounts ++;
				waittime = DWORD((float)SP_simulator_step - CP_UpdateAItime - watch.GetRecvTime()); 
				WaitForSingleObject(newsightinfo_event, waittime);
				logwait = true;
			}
		}else
			predictsightime = 0;

		//WaitForMultipleObjects(2, Handles, TRUE, waittime);// wait for the sense info and sight info
		watch.Wake();

// Update the inner world
		EnterCriticalSection(&parse_update_mutex);
		if(logwait && sensory.LastSightTime != sensory.LatestTime){
			logwaitfails ++;
			DoLog(LOG_STOPWATCH, "wait fail (%d %d)",sensory.LastSightTime, sensory.LatestTime);				
		} 
		ResetEvent(newcycle_event);
		ResetEvent(newsenseinfo_event);
		watch.UpdateStart(); 
		DoLog(LOG_NONE, "******** Cycle %.0f **********", (float)sensory.LatestTime);
		sensory.Update();
		
		LeaveCriticalSection(&parse_update_mutex);		
		
		watch.AIstart();
		
		int IsFinished = behave();

		watch.AIexit(); 

		if(!IsFinished)
			DoLog(LOG_STOPWATCH, "AI exit at %.2f",watch.GetAIEndTime());
		else{
			
		}
		DoLog(LOG_STOPWATCH, "Time elapsed on notification %f", watch.GetRecvWakeTime());
		DoLog(LOG_STOPWATCH, "Time between notification and wake %f", watch.GetWakeTime_AfterNotification());
		DoLog(LOG_STOPWATCH, "Sight Wake Time %.2f", watch.GetSightWakeTime());		
		DoLog(LOG_STOPWATCH, "Predict sight time %.2f(%d %d)", predictsightime, logwaitfails, logwaitcounts);
		DoLog(LOG_STOPWATCH, "Update start %.2f",watch.GetUpdateStartTime());
		DoLog(LOG_STOPWATCH, "AI start %.2f",watch.GetAIStartTime());
		DoLog(LOG_STOPWATCH, "AI use %.2f", watch.GetAIUseTime());
		DoLog(LOG_STOPWATCH, "AI finished at%.2f",watch.GetAIEndTime());					
	}
}

void CALLBACK CheckServer(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime){
	if (NoResponseFromServer){
		ServerAlive = 0;
		PostMessage(hwnd, WM_DESTROY, 0, 0);
	}
	NoResponseFromServer = 1;
}

void destruction(){
	int Maxwaitcounts = 100;
	int count = 0;
	DoLog(0, "Exit at %.0f",(float)sensory.LatestTime );
	if (siginf != NULL){
		TerminateThread(siginf,0);
		CloseHandle(siginf);
	}
	if (sigctrl != NULL){
		TerminateThread(sigctrl,0);
		CloseHandle(sigctrl);
	}
	DeleteCriticalSection(&parse_update_mutex);
	if(newcycle_event != NULL) CloseHandle(newcycle_event);
	if(newsightinfo_event != NULL) CloseHandle(newsightinfo_event);
	if(newsenseinfo_event != NULL) CloseHandle(newsenseinfo_event);
	if(WaitServerTimer != NULL) KillTimer(hWND, WaitServerTimer);

	close_connection(sock);
	delete sock;
}

void InitializeObjs(){
/* If I am on the right half of the court, all the coordinates shall be rotated */
	bool rotate = false;
	if (situation.MySide == 'l'){
		rotate = false;
	}
	else if (situation.MySide == 'r'){
		rotate = true;
	}
	else{
		my_error("Which side do i take?");
	}

/**************************Initialize   Markers  *************************************/

	int i=0;
	Markers[i].set_pos(-SP_pitch_length/2.0f, 0.0f ,rotate); i++; /* Goal_L */
	Markers[i].set_pos(SP_pitch_length/2.0f, 0.0f ,rotate); i++; /* Goal_R */
	Markers[i].set_pos(0.0f, 0.0f , rotate); i++; /* Flag_C */
	Markers[i].set_pos(0.0f, -SP_pitch_width/2.0f, rotate); i++; /* Flag_CT */
	Markers[i].set_pos(0.0f, SP_pitch_width/2.0f, rotate); i++; /* Flag_CB */

	Markers[i].set_pos(-SP_pitch_length/2.0f, -SP_pitch_width/2.0f, rotate); i++; /* Flag_LT */
	Markers[i].set_pos(-SP_pitch_length/2.0f, SP_pitch_width/2.0f, rotate); i++; /* Flag_LB */
	Markers[i].set_pos(SP_pitch_length/2.0f, -SP_pitch_width/2.0f, rotate); i++; /* Flag_RT */
	Markers[i].set_pos(SP_pitch_length/2.0f, SP_pitch_width/2.0f, rotate); i++; /* Flag_RB */

	Markers[i].set_pos(-SP_pitch_length/2.0f+SP_penalty_area_length,
		                -SP_penalty_area_width/2.0f, rotate); i++; /* Flag_PLT */
	Markers[i].set_pos(-SP_pitch_length/2.0f+SP_penalty_area_length, 0, rotate); i++; /* Flag_PLC */
  
	Markers[i].set_pos(-SP_pitch_length/2.0f+SP_penalty_area_length,
				SP_penalty_area_width/2.0f, rotate); i++; /* Flag_PLB */
	Markers[i].set_pos(SP_pitch_length/2.0f-SP_penalty_area_length,
				-SP_penalty_area_width/2.0f , rotate); i++; /* Flag_PRT */
	Markers[i].set_pos(SP_pitch_length/2.0f-SP_penalty_area_length, 0, rotate); i++; /* Flag_PRC */
	Markers[i].set_pos(SP_pitch_length/2.0f-SP_penalty_area_length,
				SP_penalty_area_width/2.0f, rotate); i++; /* Flag_PRB */

	Markers[i].set_pos(-SP_pitch_length/2.0f, -SP_goal_width/2.0f, rotate); i++; /* Flag_GLT */
	Markers[i].set_pos(-SP_pitch_length/2.0f, SP_goal_width/2.0f, rotate); i++; /* Flag_GLB */
	Markers[i].set_pos(SP_pitch_length/2.0f, -SP_goal_width/2.0f, rotate); i++; /* Flag_GRT */
	Markers[i].set_pos(SP_pitch_length/2.0f, SP_goal_width/2.0f, rotate); i++; /* Flag_GRB */

	Markers[i].set_pos(-50.0f, -SP_pitch_width/2.0f-SP_pitch_margin, rotate); i++; /* Flag_TL50 */
	Markers[i].set_pos(-40.0f, -SP_pitch_width/2.0f-SP_pitch_margin, rotate); i++; /* Flag_TL40 */
	Markers[i].set_pos(-30.0f, -SP_pitch_width/2.0f-SP_pitch_margin, rotate); i++; /* Flag_TL30 */
	Markers[i].set_pos(-20.0f, -SP_pitch_width/2.0f-SP_pitch_margin, rotate); i++; /* Flag_TL20 */
	Markers[i].set_pos(-10.0f, -SP_pitch_width/2.0f-SP_pitch_margin, rotate); i++; /* Flag_TL10 */
	Markers[i].set_pos(0.0f, -SP_pitch_width/2.0f-SP_pitch_margin, rotate); i++; /* Flag_T0 */
	Markers[i].set_pos(10.0f, -SP_pitch_width/2.0f-SP_pitch_margin, rotate); i++; /* Flag_TR10 */
	Markers[i].set_pos(20.0f, -SP_pitch_width/2.0f-SP_pitch_margin, rotate); i++; /* Flag_TR20 */
	Markers[i].set_pos(30.0f, -SP_pitch_width/2.0f-SP_pitch_margin, rotate); i++; /* Flag_TR30 */
	Markers[i].set_pos(40.0f, -SP_pitch_width/2.0f-SP_pitch_margin, rotate); i++; /* Flag_TR40 */
	Markers[i].set_pos(50.0f, -SP_pitch_width/2.0f-SP_pitch_margin, rotate); i++; /* Flag_TR50 */

	Markers[i].set_pos(-50.0f, SP_pitch_width/2.0f+SP_pitch_margin, rotate); i++; /* Flag_BL50 */
	Markers[i].set_pos(-40.0f, SP_pitch_width/2.0f+SP_pitch_margin, rotate); i++; /* Flag_BL40 */
	Markers[i].set_pos(-30.0f, SP_pitch_width/2.0f+SP_pitch_margin, rotate); i++; /* Flag_BL30 */
	Markers[i].set_pos(-20.0f, SP_pitch_width/2.0f+SP_pitch_margin, rotate); i++; /* Flag_BL20 */
	Markers[i].set_pos(-10.0f, SP_pitch_width/2.0f+SP_pitch_margin, rotate); i++; /* Flag_BL10 */
	Markers[i].set_pos(0.0f, SP_pitch_width/2.0f+SP_pitch_margin, rotate); i++; /* Flag_B0 */
	Markers[i].set_pos(10.0f, SP_pitch_width/2.0f+SP_pitch_margin, rotate); i++; /* Flag_BR10 */
	Markers[i].set_pos(20.0f, SP_pitch_width/2.0f+SP_pitch_margin, rotate); i++; /* Flag_BR20 */
	Markers[i].set_pos(30.0f, SP_pitch_width/2.0f+SP_pitch_margin, rotate); i++; /* Flag_BR30 */
	Markers[i].set_pos(40.0f, SP_pitch_width/2.0f+SP_pitch_margin, rotate); i++; /* Flag_BR40 */
	Markers[i].set_pos(50.0f, SP_pitch_width/2.0f+SP_pitch_margin, rotate); i++; /* Flag_BR50 */

	Markers[i].set_pos(-SP_pitch_length/2.0f-SP_pitch_margin, -30, rotate); i++; /* Flag_LT30 */
	Markers[i].set_pos(-SP_pitch_length/2.0f-SP_pitch_margin, -20, rotate); i++; /* Flag_LT20 */
	Markers[i].set_pos(-SP_pitch_length/2.0f-SP_pitch_margin, -10, rotate); i++; /* Flag_LT10 */
	Markers[i].set_pos(-SP_pitch_length/2.0f-SP_pitch_margin, 0, rotate); i++; /* Flag_L0 */
	Markers[i].set_pos(-SP_pitch_length/2.0f-SP_pitch_margin, 10, rotate); i++; /* Flag_LB10 */
	Markers[i].set_pos(-SP_pitch_length/2.0f-SP_pitch_margin, 20, rotate); i++; /* Flag_LB20 */
	Markers[i].set_pos(-SP_pitch_length/2.0f-SP_pitch_margin, 30, rotate); i++; /* Flag_LB30 */

	Markers[i].set_pos(SP_pitch_length/2.0f+SP_pitch_margin, -30, rotate); i++; /* Flag_RT30 */
	Markers[i].set_pos(SP_pitch_length/2.0f+SP_pitch_margin, -20, rotate); i++; /* Flag_RT20 */
	Markers[i].set_pos(SP_pitch_length/2.0f+SP_pitch_margin, -10, rotate); i++; /* Flag_RT10 */
	Markers[i].set_pos(SP_pitch_length/2.0f+SP_pitch_margin, 0, rotate); i++; /* Flag_R0 */
	Markers[i].set_pos(SP_pitch_length/2.0f+SP_pitch_margin, 10, rotate); i++; /* Flag_RB10 */
	Markers[i].set_pos(SP_pitch_length/2.0f+SP_pitch_margin, 20, rotate); i++; /* Flag_RB20 */
	Markers[i].set_pos(SP_pitch_length/2.0f+SP_pitch_margin, 30, rotate); /* Flag_RB30 */

	for(i = 0; i < SP_num_markers + 1; i ++)
		Markers[i].set_objtype(OBJ_Marker);
/***********       Initialize Side Lines          *********************************/

	Lines[SL_Left].set_global_angle(270,rotate);
	Lines[SL_Right].set_global_angle(90,rotate);
	Lines[SL_Top].set_global_angle(0,rotate);
	Lines[SL_Bottom].set_global_angle(180,rotate);
	for(i = 0; i < SP_num_lines + 1; i ++)
		Lines[i].set_objtype(OBJ_Line);
/**********        Intialize  Players           ****************************************/
	for(i=0; i < SP_team_size; i++){
		MyTeam[i].set_speed_param(SP_player_speed_max, SP_player_decay);
		MyTeam[i].set_conf_param(CP_conf_max, CP_conf_decay, CP_min_valid_conf);
		MyTeam[i].set_objtype(OBJ_Player);
		MyTeam[i].set_side(true);
		MyTeam[i].set_inside_no(i+1);
		MyTeam[i].SetRole(FP_attackness[i], FP_leftness[i], FP_aggressiveness[i], FP_creativeness[i]);
		TheirTeam[i].set_speed_param(SP_player_speed_max, SP_player_decay);
		TheirTeam[i].set_conf_param(CP_conf_max, CP_conf_decay, CP_min_valid_conf);
		TheirTeam[i].set_objtype(OBJ_Player);
		TheirTeam[i].set_inside_no(i+1+SP_team_size);
		TheirTeam[i].set_side(false);
		UnknownMyPlayers[i].set_speed_param(SP_player_speed_max, SP_player_decay);
		UnknownMyPlayers[i].set_conf_param(CP_conf_max, CP_conf_decay, CP_min_valid_conf);
		UnknownMyPlayers[i].set_objtype(OBJ_Player);
		UnknownMyPlayers[i].set_side(true);
		UnknownTheirPlayers[i].set_speed_param(SP_player_speed_max, SP_player_decay);
		UnknownTheirPlayers[i].set_conf_param(CP_conf_max, CP_conf_decay, CP_min_valid_conf);
		UnknownTheirPlayers[i].set_objtype(OBJ_Player);
		UnknownTheirPlayers[i].set_side(false);
		TeamlessPlayers[i].set_speed_param(SP_player_speed_max, SP_player_decay);
		TeamlessPlayers[i].set_conf_param(CP_conf_max, CP_conf_decay, CP_min_valid_conf);
		TeamlessPlayers[i].set_objtype(OBJ_Player);
		TeamlessPlayers[i+SP_team_size].set_speed_param(SP_player_speed_max, SP_player_decay);
		TeamlessPlayers[i+SP_team_size].set_conf_param(CP_conf_max, CP_conf_decay, CP_min_valid_conf);
		TeamlessPlayers[i+SP_team_size].set_objtype(OBJ_Player);
	}
	unknownmyplayerlist.set_side(Side_My);
	unknowntheirplayerlist.set_side(Side_Opp);
	teamlessplayerlist.set_side(Side_Unknown);

	Self.set_speed_param(SP_player_speed_max, SP_player_decay);
	Self.set_conf_param(CP_conf_max, CP_conf_decay, CP_min_valid_conf);
	Self.Is_goalie = CP_goalie;

/**********        Intialize   ball            ****************************************/
	ball.set_speed_param(SP_ball_speed_max,SP_ball_decay);
	ball.set_conf_param(CP_conf_max,CP_conf_decay,CP_min_valid_conf);
	ball.set_objtype(OBJ_Ball);

	strcpy(MyTeamName, CP_TeamName);
	MyTeamNameLen = strlen(MyTeamName);
/**********       Initialize  BP Networks   **********************************/
	motion.IT_Net.RestoreNet(CP_IT_weightfile);
	motion.IT_ref_Net.RestoreNet(CP_IT_ref_weigthfile);
	motion.IT_time_Net.RestoreNet(CP_IT_time_weightfile);

	motion.ControlBallNet.RestoreNet(CP_CB_weightfile);

	motion.PassNet.RestoreNet(CP_PASS_weightfile);

	fm.FMOffenseNet.RestoreNet(CP_FM_offense_weightfile);

	fm.FMDefenseNet.RestoreNet(CP_FM_defense_weightfile);

	fieldinfo.OffSensitivityNet.RestoreNet(CP_Off_sen_weightfile);
	
	fieldinfo.DF_SensitivityNet.RestoreNet(CP_DF_Sensitivity_weightfile);

	motion.Mark_Net.RestoreNet(CP_Mark_priority_weightfile);

	motion.Block_Net.RestoreNet(CP_Block_priority_weightfile);

	motion.FM_Priority_Net.RestoreNet(CP_DF_formation_priority_file);

	motion.Press_Net.RestoreNet(CP_DF_press_priority_file);

	kick.KickOA1_5.Initvpos(CP_KickOA_weightfile_A);

	kick.KickOA2_0.Initvpos(CP_KickOA_weightfile_B);

	kick.KickOA2_5.Initvpos(CP_KickOA_weightfile_C);

	kick.KickOAlast.Initvpos(CP_KickOA_weightfile_D);
/**********       Initialize  My Role      **********************************/
	Self.SetRole(CP_attackness, CP_leftness, CP_aggressiveness, CP_creativeness);
/**********       Initialize  My RSA      **********************************/
	motion.rsa.setkey(CP_encryption_matrix);
	CP_decryption_key = (int)motion.rsa.GenerateKey(CP_encryption_key);
/*********        Set Formations         *********************************/
/*********        set field information ************************************/
	fieldinfo.Initialize();
	if(fieldinfo.IsValidmygoalie()) 
		MyPlayer(fieldinfo.mygoalie).Is_goalie = true;
	if(fieldinfo.IsValidtheirgoalie()) 
		TheirPlayer(fieldinfo.theirgoalie).Is_goalie = true;
}