/* Tsinghuaeolus soccer client for Robocup2001
 *
 * Computer Science Department
 * State Key Lab of Intelligent Technology and Systems
 * Tsinghua University
 * 
 * Copyright (C) 2001 Tsinghuaeolus
 * Team Leader : Lishi
 * Team memebers : ChenJiang, YaoJinyi, CaiYunpeng
 *
 * We thank CMU for CMU98 was used for reference in our initial stage.
 *
 * You may copy and distribute this program freely as long as you retain this notice.
 * If you make any changes or have any comments we would appreciate a message to yjy01@mails.tsinghua.edu.cn.
 * For more information, please see http://www.lits.tsinghua.edu.cn/RoboCup
 */

#ifndef _dribble
#define _dribble

#include "bpn.h"
#include "types.h"
#include "Command.h"
#include "Strategy.h"

class DribbleAccount{ 
public:
	Command NextCmd;
	Vector NextBallPos; 
	DribbleAction draction;
	bool IsCriticalAction;
	int RetainCycle;
	Vector RetainPos;
	DribbleAccount(){draction = DR_NoAction;NextCmd.Reset();IsCriticalAction = false;};
};


class Dribble{
private:
	AngleDeg dribble_angle;

	bool BallInTrace(AngleDeg bodyfacing, Vector ballpos, Vector ballvel,Vector playerpos,Vector playervel,AngleDeg ball_angle,float rapidness,int IT_cycle = 3);
	bool KickAdjust(AngleDeg dribble_angle, AngleDeg ball_angle, float rapidness, DribbleAccount& draccount, Command& command);
	int TryIntercept(AngleDeg dribble_angle,Vector ballpos,Vector ballvel,Vector selfpos,Vector selfvel,float rapidness,int recovercycle = 3); 
	float GetDribbleRadius(AngleDeg ball_angle);
	bool TurnKick(AngleDeg dribble_angle, AngleDeg ball_angle, float rapidness, DribbleAccount& draccount, Command& command,int Turncycle);
public:
	Dribble();
	bool k_StepDribble(AngleDeg dribble_angle, AngleDeg ball_angle, float rapidness);
	bool k_StepDribble(AngleDeg dribble_angle, AngleDeg ball_angle, float rapidness, DribbleAccount& draccount);
	bool k_StepDribble(AngleDeg dribble_angle, AngleDeg ball_angle, float rapidness, DribbleAccount& draccount, Command& command);
	bool DribbleAvoidEnemy(DribbleAccount& draccount,Command& command); 
	bool DribbleAvoidEnemy(DribbleAccount& draccount);
	AngleDeg AvoidEnemyAngle();
	bool holdball(Command& command);
/**************    Strategy **********************/
	bool SmartDribble();
	int num_dribble;
	AngleDeg dribbleangle[12];
	bool CanDribble(AngleDeg dribble_angle); 
	AngleDeg GetBallAngle(AngleDeg dribble_angle,bool dribbleforward = true); 
	bool Covered(Vector pos,UNum opp,Time time, float buf_factor);
	float DRWeightByDistance(float distance);
	void DoDribble(AngleDeg dribble_angle, float priority);
	friend class Handleball;
};

#endif